// (C) 2001-2024 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



module bts_config (    
  input  wire          clk_fpga_p   ,    // system clock, 100M
  input  wire          fpga_resetn  ,  

//I2C interfaces
  inout  wire		   fpga_1v2_scl , 
  inout  wire		   fpga_1v2_sda , 

//LED   
  output wire          fpga_led0	, 								
  output wire          fpga_led1    ,
  output wire          fpga_led2	,
  output wire          fpga_led3          
);

//--------------------------------------------------------------------------------------------------------------------------
wire          ninit_done     ;	
wire          S_global_resetn;	  
wire          clk_50m        ;

wire          fpga_1v2_scl_in;
wire          fpga_1v2_sda_in;
wire          fpga_1v2_scl_oe;
wire          fpga_1v2_sda_oe;   

wire [3:0]    fpga_led;          
   
assign S_global_resetn = !ninit_done && fpga_resetn; //NINIT_DONE is high until the entire device enters user mode
assign fpga_led3 = fpga_led[3];
assign fpga_led2 = fpga_led[2];
assign fpga_led1 = fpga_led[1];
assign fpga_led0 = fpga_led[0];
  
  reset_release reset_release (
	.ninit_done(ninit_done)
	);
 
  sys_pll sys_pll_inst(
  	.rst      (!S_global_resetn), 
  	.refclk   (clk_fpga_p      ),
  	.locked   (  ),
  	.outclk_0 (clk_50m         )
  	); 
 
  q_sys q_sys_inst(                                                               
		.clk_clk                                     (clk_50m               ),                                     //   input,   width = 1,                                  clk.clk
		.reset_reset_n                               (S_global_resetn       ),                               //   input,   width = 1,                                reset.reset_n
		.i2c_0_i2c_serial_sda_in                     (fpga_1v2_sda_in       ),                     //   input,   width = 1,                     i2c_0_i2c_serial.sda_in
		.i2c_0_i2c_serial_scl_in                     (fpga_1v2_scl_in       ),                     //   input,   width = 1,                                     .scl_in
		.i2c_0_i2c_serial_sda_oe                     (fpga_1v2_sda_oe       ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_0_i2c_serial_scl_oe                     (fpga_1v2_scl_oe       ),                     //  output,   width = 1,                                     .scl_oe
        .pio_user_led_external_connection_export     (fpga_led              )  //  output,  width = 4, pio_user_led_external_connection.export
	);		                                                                    

assign fpga_1v2_scl_in             = fpga_1v2_scl;
assign fpga_1v2_sda_in             = fpga_1v2_sda;
assign fpga_1v2_scl                = fpga_1v2_scl_oe ? 1'b0 : 1'bz;
assign fpga_1v2_sda                = fpga_1v2_sda_oe ? 1'b0 : 1'bz;								     

endmodule	
	