// (C) 2001-2024 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1 ps / 1 ps
module  bts_rdimm_1s1r(                        
//Reset&Clock
        input           fpga_resetn,   // Reset, low active
        input           clk_fpga_p,    // system clock, 100M

        //led
		output wire        fpga_led0,
		output wire        fpga_led1,
		output wire        fpga_led2,
		output wire        fpga_led3,

         //EMIF interface
        input  wire        DDR4_DIMM1_REFCLK_P,                          //                       ddr_ref_clk.clk
		output wire        DDR4_DIMM1_CK_P0,                 //                    emif_s10_0_mem.mem_ck
		output wire        DDR4_DIMM1_CK_N0,                 //                                  .mem_ck_n
		output wire [16:0] DDR4_DIMM1_A,                    //                                  .mem_a
		output wire        DDR4_DIMM1_ACT_N,                 //                                  .mem_act_n
		output wire [1:0]  DDR4_DIMM1_BA,                    //                                  .mem_ba
		output wire [1:0]  DDR4_DIMM1_BG,                   //                                  .mem_bg		   // output wire        DDR4_DIMM1_BG1,                   //                                  .mem_bg
		output wire        DDR4_DIMM1_CKE0,                   //                                  .mem_cke
		output wire        DDR4_DIMM1_CS_N0,                  //                                  .mem_cs_n
		output wire        DDR4_DIMM1_ODT0,                   //                                  .mem_odt
		output wire        DDR4_DIMM1_RESET_N,               //                                  .mem_reset_n
		output wire        DDR4_DIMM1_PAR,                   //                                  .mem_par
		input  wire        DDR4_DIMM1_ALERT_N,               //                                  .mem_alert_n
		inout  wire [17:0]  DDR4_DIMM1_DQS_P,               //                                  .mem_dqs
		inout  wire [17:0]  DDR4_DIMM1_DQS_N,               //                                  .mem_dqs_n
		inout  wire [71:0] DDR4_DIMM1_DQ,                //                                  .mem_dq               
	    input  wire        DDR4_DIMM1_RZQ                   //                    emif_s10_0_oct.oct_rzqin//                    emif_s10_0_oct.oct_rzqin
        );
  
  reg  [26:0] heart_beat_cnt;
  wire        ninit_done;	
  wire        S_global_resetn;	  
  wire        sys_pll_locked;
  wire        clk_50m;

  wire        S_local_reset_done;
  wire        error_mon;
  wire        status_mon;
  
  assign S_global_resetn = !ninit_done && fpga_resetn;

	
  always @(posedge clk_50m or negedge S_global_resetn)
      if (!S_global_resetn)
          heart_beat_cnt <= 27'h0; //0x7ffffff
      else
          heart_beat_cnt <= heart_beat_cnt + 1'b1;	
		  
  reset_release reset_release_inst (
	.ninit_done(ninit_done)
	);

 sys_pll sys_pll_inst (
		.rst      (!S_global_resetn),      //   input,  width = 1,   reset.reset
		.refclk   (clk_fpga_p),   //   input,  width = 1,  refclk.clk
		.locked   (sys_pll_locked),   //  output,  width = 1,  locked.export
		.outclk_0 (clk_50m)  //  output,  width = 1, outclk0.clk
	);
	
	assign fpga_led3 = status_mon;
	assign fpga_led2 = !error_mon;
	assign fpga_led1 = sys_pll_locked && S_local_reset_done;
	assign fpga_led0 = heart_beat_cnt[26];
	

//----------------------------------------------------------------------------------------------------------
// DDR4 example design
//----------------------------------------------------------------------------------------------------------

ed_synth ed_synth_inst (
        .clk_50m_clk                        (clk_50m         ), 
	    .global_reset_reset_n               (sys_pll_locked  ),
		.emif_fm_0_pll_ref_clk_clk          (DDR4_DIMM1_REFCLK_P),          //   input,   width = 1, emif_fm_0_pll_ref_clk.clk
		.emif_fm_0_oct_oct_rzqin            (DDR4_DIMM1_RZQ),            //   input,   width = 1,         emif_fm_0_oct.oct_rzqin
		.emif_fm_0_mem_mem_ck               (DDR4_DIMM1_CK_P0),               //  output,   width = 1,         emif_fm_0_mem.mem_ck
		.emif_fm_0_mem_mem_ck_n             (DDR4_DIMM1_CK_N0),             //  output,   width = 1,                      .mem_ck_n
		.emif_fm_0_mem_mem_a                (DDR4_DIMM1_A),                //  output,  width = 17,                      .mem_a
		.emif_fm_0_mem_mem_act_n            (DDR4_DIMM1_ACT_N),            //  output,   width = 1,                      .mem_act_n
		.emif_fm_0_mem_mem_ba               (DDR4_DIMM1_BA),               //  output,   width = 2,                      .mem_ba
		.emif_fm_0_mem_mem_bg               (DDR4_DIMM1_BG),               //  output,   width = 2,                      .mem_bg
		.emif_fm_0_mem_mem_cke              (DDR4_DIMM1_CKE0),              //  output,   width = 1,                      .mem_cke
		.emif_fm_0_mem_mem_cs_n             (DDR4_DIMM1_CS_N0),             //  output,   width = 1,                      .mem_cs_n
		.emif_fm_0_mem_mem_odt              (DDR4_DIMM1_ODT0),              //  output,   width = 1,                      .mem_odt
		.emif_fm_0_mem_mem_reset_n          (DDR4_DIMM1_RESET_N),          //  output,   width = 1,                      .mem_reset_n
		.emif_fm_0_mem_mem_par              (DDR4_DIMM1_PAR),              //  output,   width = 1,                      .mem_par
		.emif_fm_0_mem_mem_alert_n          (DDR4_DIMM1_ALERT_N),          //   input,   width = 1,                      .mem_alert_n
		.emif_fm_0_mem_mem_dqs              (DDR4_DIMM1_DQS_P),              //   inout,   width = 18,                      .mem_dqs
		.emif_fm_0_mem_mem_dqs_n            (DDR4_DIMM1_DQS_N),            //   inout,   width = 18,                      .mem_dqs_n
		.emif_fm_0_mem_mem_dq               (DDR4_DIMM1_DQ),               //   inout,  width = 72,                      .mem_dq
		.local_reset_req_local_reset_req    (sys_pll_locked),
	    .local_reset_status_local_reset_done(S_local_reset_done),
	    .master_driver_msgdma_0_error_mon_export (error_mon),         //error_mon     = error_status;
	    .master_driver_msgdma_0_status_mon_export(status_mon)         //status_mon=cal_success & test_run_valid & (!test_timeout);
	);
endmodule