#!/bin/sh

echo "****************************************"
echo "*          BOARD TEST SYSTEM           *"
echo "****************************************"
echo ""

ROOTDIR=/opt/Java/
JRE=jre
JFX=jfx

if [ ! -d $ROOTDIR$JRE  -o ! -d $ROOTDIR$JFX ]; then
        echo "----------------------------------------"
        echo "JAVA environment setting is not correct!"
        echo "----------------------------------------"

        if [ ! -d $ROOTDIR$JRE ]; then
                echo "JRE does not exist on system"
                echo "Please download Temurin 11 JRE [LTS] from: https://adoptium.net/releases.html"
                echo "And unzip the downloaded file to: $ROOTDIR$JRE"
                echo ""
        fi

        if [ ! -d $ROOTDIR$JFX ]; then
                echo "JFX does not exist on system"
                echo "Please download JavaFX 17.0.2 [LTS] from: https://gluonhq.com/products/javafx/"
                echo "And unzip the downloaded file to: $ROOTDIR$JFX"
                echo ""
        fi

	exit
fi

echo "Board Test System starting..."
if [ ! -f lib/javafx.base.jar ]; then
        echo "Copying JavaFX library..."
        cp $ROOTDIR$JFX/lib/*.jar lib/
fi

$ROOTDIR$JRE/bin/java --module-path $ROOTDIR$JFX/lib --add-modules javafx.controls,javafx.fxml,javafx.web -jar bts.jar

