`timescale 1ns / 100ps
module  golden_top (
    //Reset&Clock
        input  wire        clk_fpga_p         , // system clock, 100M
        input  wire        fpga_resetn        , //system global reset
										   
    //I2C                         
        inout  wire		   fpga_1v2_scl       , 
        inout  wire		   fpga_1v2_sda       , 
		input  wire        ioexp_intn         ,  //interrupt from I2C Expander
										   
    //leds                  
        output wire        fpga_led0        ,
        output wire        fpga_led1        ,
        output wire        fpga_led2        ,    
        output wire        fpga_led3        , 
		output wire        qsfp_led1        ,
		output wire        qsfp_led2        ,
		output wire        qsfpdd_led1      ,
		output wire        qsfpdd_led2      ,
		
	//GPIO between MAX10 and FPGA
	    inout  wire		    fpga_max_gpio0  ,
		inout  wire		    fpga_max_gpio1  ,
		inout  wire		    fpga_max_gpio2  ,
		inout  wire		    fpga_max_gpio3  ,
	
	//1PPS/ToD
	    output wire         pps_fpga_clkout      ,
	    input  wire         tod_master_clk_125m_p,
		input  wire         ptp_sample_clk_250m_p,
										   
    //RDIMM1
        input  wire        DDR4_DIMM1_REFCLK_P,                          //                       ddr_ref_clk.clk
		output wire        DDR4_DIMM1_CK_P0,                 //                    emif_s10_0_mem.mem_ck
		output wire        DDR4_DIMM1_CK_N0,                 //                                  .mem_ck_n
		output wire [16:0] DDR4_DIMM1_A,                    //                                  .mem_a
		output wire        DDR4_DIMM1_ACT_N,                 //                                  .mem_act_n
		output wire [1:0]  DDR4_DIMM1_BA,                    //                                  .mem_ba
		output wire [1:0]  DDR4_DIMM1_BG,                   //                                  .mem_bg		   // output wire        DDR4_DIMM1_BG1,                   //                                  .mem_bg
		output wire        DDR4_DIMM1_CKE0,                   //                                  .mem_cke
		output wire        DDR4_DIMM1_CS_N0,                  //                                  .mem_cs_n
		output wire        DDR4_DIMM1_ODT0,                   //                                  .mem_odt
		output wire        DDR4_DIMM1_RESET_N,               //                                  .mem_reset_n
		output wire        DDR4_DIMM1_PAR,                   //                                  .mem_par
		input  wire        DDR4_DIMM1_ALERT_N,               //                                  .mem_alert_n
		inout  wire [17:0]  DDR4_DIMM1_DQS_P,               //                                  .mem_dqs
		inout  wire [17:0]  DDR4_DIMM1_DQS_N,               //                                  .mem_dqs_n
		inout  wire [71:0] DDR4_DIMM1_DQ,                //                                  .mem_dq               
	    input  wire        DDR4_DIMM1_RZQ,                   //                    emif_s10_0_oct.oct_rzqin//                    emif_s10_0_oct.oct_rzqin 

	//RDIMM2
        input  wire        DDR4_DIMM_2_REFCLKP,                          //                       ddr_ref_clk.clk
		output wire        DDR4_DIMM_2_CKP0,                 //                    emif_s10_0_mem.mem_ck
		output wire        DDR4_DIMM_2_CKN0,                 //                                  .mem_ck_n
		output wire [16:0] DDR4_DIMM_2_A,                    //                                  .mem_a
		output wire        DDR4_DIMM_2_ACTN,                 //                                  .mem_act_n
		output wire [1:0]  DDR4_DIMM_2_BA,                    //                                  .mem_ba
		output wire [1:0]  DDR4_DIMM_2_BG,                   //                                  .mem_bg		   // output wire        DDR4_DIMM_2_BG1,                   //                                  .mem_bg
		output wire        DDR4_DIMM_2_CKE0,                   //                                  .mem_cke
		output wire        DDR4_DIMM_2_CSN0,                  //                                  .mem_cs_n
		output wire        DDR4_DIMM_2_ODT0,                   //                                  .mem_odt
		output wire        DDR4_DIMM_2_RSTN,               //                                  .mem_reset_n
		output wire        DDR4_DIMM_2_PAR,                   //                                  .mem_par
		input  wire        DDR4_DIMM_2_ALERTN,               //                                  .mem_alert_n
		inout  wire [17:0]  DDR4_DIMM_2_DQSP,               //                                  .mem_dqs
		inout  wire [17:0]  DDR4_DIMM_2_DQSN,               //                                  .mem_dqs_n
		inout  wire [71:0] DDR4_DIMM_2_DQ,                //                                  .mem_dq               
	    input  wire        DDR4_DIMM_2_RZQ,                   //                    emif_s10_0_oct.oct_rzqin//                    emif_s10_0_oct.oct_rzqin	
		
	//HPS DDR4 COMP
        input  wire        DDR4_HPS_REFCLKP,                          //                       ddr_ref_clk.clk
		output wire        DDR4_HPS_CKP,                 //                    emif_s10_0_mem.mem_ck
	    output wire        DDR4_HPS_CKN,                 //                                  .mem_ck_n
		output wire [16:0] DDR4_HPS_A,                    //                                  .mem_a
		output wire        DDR4_HPS_ACTN,                 //                                  .mem_act_n
		output wire [1:0]  DDR4_HPS_BA,                    //                                  .mem_ba
	    output wire  [1:0] DDR4_HPS_BG,                   //                                  .mem_bg		  
		output wire        DDR4_HPS_CKE,                   //                                  .mem_cke
		output wire        DDR4_HPS_CSN,                  //                                  .mem_cs_n
		output wire        DDR4_HPS_ODT,                   //                                  .mem_odt
		output wire        DDR4_HPS_RSTN,               //                                  .mem_reset_n
		output wire        DDR4_HPS_PAR,                   //                                  .mem_par
		input  wire        DDR4_HPS_ALERTN,               //                                  .mem_alert_n
		inout  wire [4:0]  DDR4_HPS_DQSP,               //                                  .mem_dqs
		inout  wire [4:0]  DDR4_HPS_DQSN,               //                                  .mem_dqs_n
		inout  wire [39:0] DDR4_HPS_DQ,                //                                  .mem_dq
		inout  wire [4:0]  DDR4_HPS_DBI,                 //                                  .mem_dbi_n
		input  wire        DDR4_HPS_RZQ,                   //                    emif_s10_0_oct.oct_rzqin
		
	//QSFP56
		input  wire        qsfp_refclk_p  , // QSFP56 reference clock 156.25MHz
        input  wire [3:0]  qsfp_rx_p      , 
        input  wire [3:0]  qsfp_rx_n      , 
        output wire [3:0]  qsfp_tx_p      , 
        output wire [3:0]  qsfp_tx_n      ,
		
	//QSFPDD
		input  wire        qsfpdd_refclk_p  , // QSFPDD reference clock 156.25MHz
		input  wire [7:0]  qsfpdd_rx_p      , 
        input  wire [7:0]  qsfpdd_rx_n      , 
        output wire [7:0]  qsfpdd_tx_p      , 
        output wire [7:0]  qsfpdd_tx_n      , 
		
	//CXL
	    input  wire         cxl_prsntx4_n,  //indicate if cxl daughter card is hooked up or not
		output wire         fpga_cxl_rstn,  //when functions as RP, use this signal as global Perstn to both EP and cxl_pin_perst_pin_perst
		input  wire			cxl_refclk_fgt_in_refclk_fgt_1,
		input  wire         cxl_pin_perst_pin_perst,                //         pin_perst.pin_perst,             
		input  wire         cxl_hip_serial_rx_n_in0,                   //        hip_serial.rx_n_in0,              
		input  wire         cxl_hip_serial_rx_n_in1,                   //                  .rx_n_in1,              
		input  wire         cxl_hip_serial_rx_n_in2,                   //                  .rx_n_in2,              
		input  wire         cxl_hip_serial_rx_n_in3,                   //                  .rx_n_in3,              
		input  wire         cxl_hip_serial_rx_p_in0,                   //                  .rx_p_in0,              
		input  wire         cxl_hip_serial_rx_p_in1,                   //                  .rx_p_in1,              
		input  wire         cxl_hip_serial_rx_p_in2,                   //                  .rx_p_in2,              
		input  wire         cxl_hip_serial_rx_p_in3,                   //                  .rx_p_in3,              
		output wire         cxl_hip_serial_tx_n_out0,                  //                  .tx_n_out0,             
		output wire         cxl_hip_serial_tx_n_out1,                  //                  .tx_n_out1,             
		output wire         cxl_hip_serial_tx_n_out2,                  //                  .tx_n_out2,             
		output wire         cxl_hip_serial_tx_n_out3,                  //                  .tx_n_out3,             
		output wire         cxl_hip_serial_tx_p_out0,                  //                  .tx_p_out0,             
		output wire         cxl_hip_serial_tx_p_out1,                  //                  .tx_p_out1,             
		output wire         cxl_hip_serial_tx_p_out2,                  //                  .tx_p_out2,             
		output wire         cxl_hip_serial_tx_p_out3,                  //                  .tx_p_out3,             
		
	//PCIE
	    input  wire         pciex8_bif_perstn0,
		input  wire         pciex8_bif_perstn1,
		input  wire			refclk_fgt_in_refclk_fgt_1,
        input  wire         pin_perst_pin_perst,                //         pin_perst.pin_perst,             
		input  wire         hip_serial_rx_n_in0,                   //        hip_serial.rx_n_in0,              
		input  wire         hip_serial_rx_n_in1,                   //                  .rx_n_in1,              
		input  wire         hip_serial_rx_n_in2,                   //                  .rx_n_in2,              
		input  wire         hip_serial_rx_n_in3,                   //                  .rx_n_in3,              
		input  wire         hip_serial_rx_n_in4,                   //                  .rx_n_in4,              
		input  wire         hip_serial_rx_n_in5,                   //                  .rx_n_in5,              
		input  wire         hip_serial_rx_n_in6,                   //                  .rx_n_in6,              
		input  wire         hip_serial_rx_n_in7,                   //                  .rx_n_in7,              
		input  wire         hip_serial_rx_n_in8,                   //                  .rx_n_in8,              
		input  wire         hip_serial_rx_n_in9,                   //                  .rx_n_in9,              
		input  wire         hip_serial_rx_n_in10,                  //                  .rx_n_in10,             
		input  wire         hip_serial_rx_n_in11,                  //                  .rx_n_in11,             
		input  wire         hip_serial_rx_n_in12,                  //                  .rx_n_in12,             
		input  wire         hip_serial_rx_n_in13,                  //                  .rx_n_in13,             
		input  wire         hip_serial_rx_n_in14,                  //                  .rx_n_in14,             
		input  wire         hip_serial_rx_n_in15,                  //                  .rx_n_in15,             
		input  wire         hip_serial_rx_p_in0,                   //                  .rx_p_in0,              
		input  wire         hip_serial_rx_p_in1,                   //                  .rx_p_in1,              
		input  wire         hip_serial_rx_p_in2,                   //                  .rx_p_in2,              
		input  wire         hip_serial_rx_p_in3,                   //                  .rx_p_in3,              
		input  wire         hip_serial_rx_p_in4,                   //                  .rx_p_in4,              
		input  wire         hip_serial_rx_p_in5,                   //                  .rx_p_in5,              
		input  wire         hip_serial_rx_p_in6,                   //                  .rx_p_in6,              
		input  wire         hip_serial_rx_p_in7,                   //                  .rx_p_in7,              
		input  wire         hip_serial_rx_p_in8,                   //                  .rx_p_in8,              
		input  wire         hip_serial_rx_p_in9,                   //                  .rx_p_in9,              
		input  wire         hip_serial_rx_p_in10,                  //                  .rx_p_in10,             
		input  wire         hip_serial_rx_p_in11,                  //                  .rx_p_in11,             
		input  wire         hip_serial_rx_p_in12,                  //                  .rx_p_in12,             
		input  wire         hip_serial_rx_p_in13,                  //                  .rx_p_in13,             
		input  wire         hip_serial_rx_p_in14,                  //                  .rx_p_in14,             
		input  wire         hip_serial_rx_p_in15,                  //                  .rx_p_in15,             
		output wire         hip_serial_tx_n_out0,                  //                  .tx_n_out0,             
		output wire         hip_serial_tx_n_out1,                  //                  .tx_n_out1,             
		output wire         hip_serial_tx_n_out2,                  //                  .tx_n_out2,             
		output wire         hip_serial_tx_n_out3,                  //                  .tx_n_out3,             
		output wire         hip_serial_tx_n_out4,                  //                  .tx_n_out4,             
		output wire         hip_serial_tx_n_out5,                  //                  .tx_n_out5,             
		output wire         hip_serial_tx_n_out6,                  //                  .tx_n_out6,             
		output wire         hip_serial_tx_n_out7,                  //                  .tx_n_out7,             
		output wire         hip_serial_tx_n_out8,                  //                  .tx_n_out8,             
		output wire         hip_serial_tx_n_out9,                  //                  .tx_n_out9,             
		output wire         hip_serial_tx_n_out10,                 //                  .tx_n_out10,            
		output wire         hip_serial_tx_n_out11,                 //                  .tx_n_out11,            
		output wire         hip_serial_tx_n_out12,                 //                  .tx_n_out12,            
		output wire         hip_serial_tx_n_out13,                 //                  .tx_n_out13,            
		output wire         hip_serial_tx_n_out14,                 //                  .tx_n_out14,            
		output wire         hip_serial_tx_n_out15,                 //                  .tx_n_out15,            
		output wire         hip_serial_tx_p_out0,                  //                  .tx_p_out0,             
		output wire         hip_serial_tx_p_out1,                  //                  .tx_p_out1,             
		output wire         hip_serial_tx_p_out2,                  //                  .tx_p_out2,             
		output wire         hip_serial_tx_p_out3,                  //                  .tx_p_out3,             
		output wire         hip_serial_tx_p_out4,                  //                  .tx_p_out4,             
		output wire         hip_serial_tx_p_out5,                  //                  .tx_p_out5,             
		output wire         hip_serial_tx_p_out6,                  //                  .tx_p_out6,             
		output wire         hip_serial_tx_p_out7,                  //                  .tx_p_out7,             
		output wire         hip_serial_tx_p_out8,                  //                  .tx_p_out8,             
		output wire         hip_serial_tx_p_out9,                  //                  .tx_p_out9,             
		output wire         hip_serial_tx_p_out10,                 //                  .tx_p_out10,            
		output wire         hip_serial_tx_p_out11,                 //                  .tx_p_out11,            
		output wire         hip_serial_tx_p_out12,                 //                  .tx_p_out12,            
		output wire         hip_serial_tx_p_out13,                 //                  .tx_p_out13,            
		output wire         hip_serial_tx_p_out14,                 //                  .tx_p_out14,            
		output wire         hip_serial_tx_p_out15                 //                  .tx_p_out15,            
  );
  