/*****************************************************************************
 * INTEL CONFIDENTIAL
 * Copyright 2024 Intel Corporation.  All Rights Reserved.
 *
 * The source code contained or described herein and all documents related
 * to the source code ("Material") are owned by Intel Corporation or its
 * suppliers or licensors. Title to the Material remains with Intel
 * Corporation or its suppliers and licensors. The Material contains trade
 * secrets and proprietary and confidential information of Intel or its
 * suppliers and licensors. The Material is protected by worldwide copyright
 * and trade secret laws and treaty provisions. No part of the Material may
 * be used, copied, reproduced, modified, published, uploaded, posted,
 * transmitted, distributed, or disclosed in any way without Intel's prior
 * express written permission.
 *
 * No license under any patent, copyright, trade secret or other intellectual
 * property right is granted to or conferred upon you by disclosure or
 * delivery of the Materials, either expressly, by implication, inducement,
 * estoppel or otherwise. Any license under such intellectual property rights
 * must be express and approved by Intel in writing.
 *****************************************************************************/

#ifndef __I2C_INTERFACE_H__
#define __I2C_INTERFACE_H__

#include "altera_avalon_i2c.h"

#define ERR_PARAM    (-20)

#define ITL_I2C_0_BUS 1

/*  @i2c_dev_id i2c master number (1)
    @addr:          i2c slave address
    @reg:           register address, could be 8bit or 16bit width
    @*data:         the data read from i2c device
    @bitWidth:      accpt 8(bit), 16(bit), 24(bit) and 32(bit), other value would cause an error
    @return:        Status Code,   */
ALT_AVALON_I2C_STATUS_CODE itl_i2c_read_reg(int i2c_dev_id, alt_u8 addr, alt_u16 reg, alt_u32*data, alt_u8 bitwidth);

/*  @i2c_dev_id i2c master number (1)
    @addr:          i2c slave address
    @reg:           register address, could be 8bit or 16bit width
    @data:      the data write to i2c device
    @bitWidth:      accpt 8(bit), 16(bit), 24(bit) and 32(bit), other value would cause an error
    @return:        Status Code,   */
ALT_AVALON_I2C_STATUS_CODE itl_i2c_write_reg(int i2c_dev_id, alt_u8 addr, alt_16 reg, alt_u32 data, alt_u8 bitwidth);

int itl_i2c_open_devices();

#endif
