/*****************************************************************************
 * INTEL CONFIDENTIAL
 * Copyright 2024 Intel Corporation.  All Rights Reserved.
 *
 * The source code contained or described herein and all documents related
 * to the source code ("Material") are owned by Intel Corporation or its
 * suppliers or licensors. Title to the Material remains with Intel
 * Corporation or its suppliers and licensors. The Material contains trade
 * secrets and proprietary and confidential information of Intel or its
 * suppliers and licensors. The Material is protected by worldwide copyright
 * and trade secret laws and treaty provisions. No part of the Material may
 * be used, copied, reproduced, modified, published, uploaded, posted,
 * transmitted, distributed, or disclosed in any way without Intel's prior
 * express written permission.
 *
 * No license under any patent, copyright, trade secret or other intellectual
 * property right is granted to or conferred upon you by disclosure or
 * delivery of the Materials, either expressly, by implication, inducement,
 * estoppel or otherwise. Any license under such intellectual property rights
 * must be express and approved by Intel in writing.
 *****************************************************************************/
#include <stdio.h>
#include "io.h"
#include "alt_types.h"
#include "config.h"
#include "itl_i2c_interface.h"
#include "itl_pca9534.h"

alt_u32 itl_pca9534_out_read_reg(alt_u8 slave_addr, alt_u16 reg, alt_u32 *data)
{
    return itl_i2c_read_reg(ITL_I2C_0_BUS, slave_addr, reg, data, 8);
}

alt_u32 itl_pca9534_out_write_reg(alt_u8 slave_addr, alt_u16 reg, alt_u32 data)
{
    return itl_i2c_write_reg(ITL_I2C_0_BUS, slave_addr, reg, data, 8);
}

alt_u32 itl_pca9534_read_reg(alt_u16 reg, alt_u32 *data)
{
    return itl_i2c_read_reg(ITL_I2C_0_BUS, ITL_ADDR_PCA9534, reg, data, 8);
}

alt_u32 itl_pca9534_write_reg(alt_u16 reg, alt_u32 data)
{
    return itl_i2c_write_reg(ITL_I2C_0_BUS, ITL_ADDR_PCA9534, reg, data, 8);
}
