
/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */

#include <stdio.h>
#include <string.h>
#include "unistd.h"
#include "priv/alt_busy_sleep.h"
#include "config.h"
#include "itl_i2c_interface.h"
#include "itl_pca9534.h"
#include "itl_qsfp.h"

int main()
{
    alt_u32 data = 0;
    ALT_AVALON_I2C_STATUS_CODE ret = 0;

    printf("FM86 board NIOSV firmware version: %X\n", ITL_BUILD_VERSION);

    if(itl_i2c_open_devices() < 0)
    {
        return ITL_FAIL;
    }

    printf("\nqsfp test:\n");
    ITL_PCA9534_WRITE(ITL_ADDR_PCA9534, ITL_PCA9534_REG_CONFIG, (alt_u32)0x32);//Output: P0 P2 P3 P6 P7  Input: P1 P4 P5
    ITL_PCA9534_WRITE(ITL_ADDR_PCA9534, ITL_PCA9534_REG_OUT,    (alt_u32)0x41);//high: P0 P6  low: P2 P3 P7
    ITL_PCA9534_READ(ITL_ADDR_PCA9534, ITL_PCA9534_REG_IN);
    ITL_PCA9534_READ(ITL_ADDR_QSFP_QSFPDD, ITL_QSFP_REG_MANAGECHARACTER0);
    ITL_PCA9534_READ(ITL_ADDR_QSFP_QSFPDD, ITL_QSFP_REG_MANAGECHARACTER1);
    ITL_PCA9534_READ(ITL_ADDR_QSFP_QSFPDD, ITL_QSFP_REG_MANAGECHARACTER2);

    printf("\nqsfpdd test:\n");
    ITL_PCA9534_WRITE(ITL_ADDR_PCA9534, ITL_PCA9534_REG_CONFIG, (alt_u32)0x32);//Output: P0 P2 P3 P6 P7  Input: P1 P4 P5
    ITL_PCA9534_WRITE(ITL_ADDR_PCA9534, ITL_PCA9534_REG_OUT,    (alt_u32)0x81);//high: P0 P7 low: P2 P3 P6
    ITL_PCA9534_READ(ITL_ADDR_PCA9534, ITL_PCA9534_REG_IN);
    ITL_PCA9534_READ(ITL_ADDR_QSFP_QSFPDD, ITL_QSFP_REG_MANAGECHARACTER0);
    ITL_PCA9534_READ(ITL_ADDR_QSFP_QSFPDD, ITL_QSFP_REG_MANAGECHARACTER1);
    ITL_PCA9534_READ(ITL_ADDR_QSFP_QSFPDD, ITL_QSFP_REG_MANAGECHARACTER2);

    while(1)
    {
        usleep(1);
    }
    return ITL_SUCCESS;
}
